unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, Vcl.Grids, system.UITypes,
  Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    Memo1: TMemo;
    StringGrid1: TStringGrid;
    StringGrid2: TStringGrid;
    LabeledEdit1: TLabeledEdit;
    BitBtn2: TBitBtn;
    RadioGroup1: TRadioGroup;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
  private
    { Private 錾 }
    function LUecomposition: byte;
    procedure GridSet(Sin, Colin: integer);    // ObhTCYύX
    procedure rowmatinc(k: integer);
    procedure testset;
    function triangular_matrix(var z : integer): extended;
    procedure permutation;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var
  Nltest : integer = 4;             // eXgf[^[s
                                    // eXgf[^[
  mattestA : array[0..3] of array[0..3] of extended = ((8, 16, 24, 32),
                                                       (2,  7, 12, 17),
                                                       (6, 17, 32, 59),
                                                       (7, 22, 46,105));
  mattestB : array[0..3] of array[0..3] of extended = ((8, 16, 24,  32),
                                                       (2,  7, 12,  17),
                                                       (2, 17, 32,   0),
                                                       (7,  0,  0, 105));
  mattestC : array[0..3] of array[0..3] of extended = ((8, 16, 24,   0),
                                                       (2,  7, 12,   0),
                                                       (2, 17, 32,   0),
                                                       (7,  0,  0, 105));
  mattestD : array[0..3] of array[0..3] of extended = ((0,  16, 24,  32),
                                                       (2,  7, 12,  17),
                                                       (6, 17, 32,   0),
                                                       (7,  0,  0, 105));
  mattestE : array[0..3] of array[0..3] of extended = ((0,  0,  0,  32),
                                                       (0,  0, 12,  17),
                                                       (6, 17, 32,   0),
                                                       (7,  0,  0, 105));

  btestA    : array[0..3] of extended = (160, 70, 198, 291);
  btestB    : array[0..3] of extended = (150, 60, 10, 40);

  Nl : integer;                       // s
  matA : array of array of extended;  // Asz
  matL : array of array of extended;  // Lsz
  matU : array of array of extended;  // Usz
  lu   : array of array of extended;
  b    : array of extended;
  ba   : array of extended;
  a    : array of array of extended;
  perNo : array of array of integer;  // SsNoz

  rowNo : array of integer;
  exchange : integer;

  diagonal : integer;


// Obh̐ݒ
procedure TForm1.GridSet(Sin, Colin: integer);    // ObhTCYύX
var                                               // f[^[s̐10
  H, W, i :integer;                               // ȏ̓XN[
begin
  inc(Sin);
  inc(Colin);
  StringGrid1.ColCount := Colin;
  StringGrid1.RowCount := Sin;
  if Sin <= 11 then                               // XgOObh̑傫ݒ
    begin                                         // Œs܂11s͂ȉ̏ꍇ
      H := (StringGrid1.DefaultRowHeight + 1) * Sin;
      StringGrid2.ScrollBars := ssNone;           // XN[o[\
    end
    else
    begin                                         // Œs܂11s葽ꍇ
      H := (StringGrid1.DefaultRowHeight + 1) * (10 + 1);
      StringGrid2.ScrollBars := ssVertical;       // XN[o[\
    end;
  if Colin <= 11 then                             // XgOObh̑傫ݒ
    begin                                         // Œs܂11s͂ȉ̏ꍇ
      W := (StringGrid1.DefaultColWidth + 1) * Colin;
      StringGrid1.ScrollBars := ssNone;           // XN[o[Ȃ
    end
    else
    begin                                         // Œs܂11s葽ꍇ
      W := (StringGrid1.DefaultColWidth + 1) * (10 + 1);
      StringGrid1.ScrollBars := ssBoth;           // XN[o[\
    end;
  StringGrid1.ClientWidth := W;
  StringGrid1.ClientHeight := H;
  for i := 1 to Sin - 1 do StringGrid1.Cells[0,i] := 'a' + intTostr(i) + '*';
  for i := 1 to Sin - 1 do StringGrid1.Cells[i,0] := 'a*' + intTostr(i);
  StringGrid2.RowCount := Sin;
  StringGrid2.ClientHeight := H + 1;
  StringGrid2.ClientWidth := (StringGrid2.DefaultColWidth + 1) * 2;
  for i := 1 to Sin - 1 do StringGrid2.Cells[0, i] := intTostr(i);
  StringGrid2.Cells[1, 0] := 'b*=';
end;

// s̓ւ ΊpɃ[ɍs̓ւs܂B
procedure TForm1.rowmatinc(k: integer);
var
  i : integer;
begin
  for i := 0 to Nl - 1 do rowNo[i] := perNo[k, i];
end;

// s񎮂̒l
// PɑΊpɃ[邩ǂ̊mF
// Ίp̌vZl[ɂȂ̂ɉZ덷Ń[ɂȂȂƂ
function TForm1.triangular_matrix(var z : integer): extended;
var
  i, j, k, m, q: integer;
  buf, det: extended;
  c : array of array of extended;
  p : array of integer;
begin
  setlength(c, Nl, Nl);
  setlength(p, Nl);
  for i := 0 to Nl - 1 do begin
    p[i] := i;
    for j := 0 to Nl - 1 do
      c[i, j] := matA[i, j];
  end;
  z := 0;
  det := 1;
  // Ops̍쐬
  for i := 0 to Nl -1 do
    for j := 0 to Nl -1 do
      if i < J then begin
        if c[i, i] = 0 then begin
          for k := i + 1 to Nl - 1 do
            if c[k, i] <> 0 then begin
              det := -det;
              for m := 0 to Nl - 1 do begin
                buf := c[i,  m];
                c[i, m] := c[k, m];
                c[k, m] := buf;
              end;
              q := p[i];
              p[i] := p[k];
              p[k] := q;
            end;
        end
        else begin
          buf := c[j, i] / c[i, i];
          for k := 0 to Nl - 1 do c[j, k] := c[j, k] - c[i, k] * buf;
        end;
      end;

  // Ίps̐
  for i := 0 to Nl - 1 do begin
    det := det * c[i, i];
    if c[i, i] = 0 then z := p[i] + 1;
  end;
  result := det;

  memo1.Lines.Append('s񎮂̒l ' + floattostr(det));
end;

// SsNogݍ킹z쐬
procedure TForm1.permutation;
var
  v : array of integer;
  i, n : integer;

  procedure swap(var pa, pb : integer);
  var
    tmp : integer;
  begin
    tmp := pa;
    pa := pb;
    pb := tmp;
  end;

  procedure reverse(first, last: integer);
  var
    lam : integer;
  begin
    lam := last;
    dec(lam);
    while (first <> last) and (first <> lam) do begin
      swap(v[first], v[lam]);
      inc(first);
      last := lam;
      dec(lam);
    end;
  end;

  function next_permutation(first, last: integer): boolean;
  var
    i, j, k : integer;
  begin
    if first = last then begin
      result := false;
      exit;
    end;
    if first + 1 = last then begin
      result := false;
      exit;
    end;
    i := last - 1;
    while true do begin
      j := i;
      dec(i);
      if v[i] < v[j] then begin
        k := last;
        dec(k);
        while not(v[i] < v[k]) do dec(k);
        swap(v[i], v[k]);
        reverse(j,  last);
        result := true;
        exit;
      end;
      if i = first then begin
        reverse(j,  last);
        result := false;
        exit;
      end;
    end;
  end;

begin
  setlength(v, Nl);
  for i := 0 to Nl -1 do v[i] := i;
  n := 0;
  repeat
    for i := 0 to Nl - 1 do perNo[n, i] := v[i];
    inc(n);
  until not next_permutation(0, Nl);
end;


// LUɂẢ@
function TForm1.LUecomposition: byte;
const
  sp = ' ';
var
  i, j, k, n : integer;
  sum : extended;
  aa : array of array of extended;
  l, u, x, y : array of extended;
  LL, spl : string;
begin
  setlength(a, Nl, Nl);
  setlength(aa, Nl, Nl);

  setlength(l, Nl);
  setlength(u, Nl);
  setlength(x, Nl);
  setlength(y, Nl);


  // matf[^[ҏWpɃRs[           matA, B
  for j := 0 to Nl - 1 do begin
    ba[j ] := b[rowNo[j]];
    for k := 0 to Nl - 1 do a[j, k] := matA[rowNo[j], k];
  end;

  // ҏWpobNAbvɂɃRs[
  for j := 0 to Nl - 1 do
    for k := 0 to Nl - 1 do
      aa[j, k] := a[j, k];

  // matȖΊp1ɐݒ
  for i := 0 to Nl - 1 do
    for j := 0 to Nl - 1 do
      if i = j then begin
        matU[i, j] := 1;
        matL[i, j] := 0;
      end
      else begin
        matU[i, j] := 0;
        matL[i, j] := 0;
      end;

  // LU
  for i := 0 to Nl -1 do begin
    n := Nl - i - 1;
    // matA擪̒lmatL̑ΊpɃZbg
    // Ίp[I
    if a[0, 0] = 0 then begin
      break;
    end;
    matL[i, i] := a[0, 0];
    // MatL̍쐬
    for j := 0 to n - 1 do begin
      l[j] := a[j + 1, 0];
      matL[j + i + 1, i] := l[j];
    end;
    // matU̍쐬
    for j := 0 to n - 1 do begin
      u[j] := a[0, j + 1] / a[0, 0];
      matU[i, j + i + 1] := u[j];
    end;
    // lu߂
    for j := 0 to n - 1 do begin
      for k := 0 to n - 1 do begin
        lu[j, k] := l[j] * u[k];
      end;
    end;
    // a߂
    for j := 0 to n - 1 do begin
      for k := 0 to n - 1 do begin
        a[j, k] := a[j + 1, k + 1] - lu[j, k];
      end;
    end;
  end;

  diagonal := Nl;

  // ΊpɃ[ꍇZ𒆎~'
  // s̓ւ݂܂
  if a[0, 0] = 0 then begin
    result := 1;
    diagonal := i;
    exit;
  end;

  // LUsŘA܂
  for i := 0 to Nl - 1 do begin
    sum := 0;
    for k := 0 to i - 1 do sum := sum + matL[i, k] * y[k];
    y[i] := (ba[i] - sum) / matL[i, i];
  end;
  // ޑ
  for i := Nl - 1 downto 0 do begin
    sum := 0;
    for k := i + 1 to Nl - 1 do sum := sum + matU[i, k] * x[k];
    x[i] := y[i] - sum;
  end;

  // es̍vZ
  for j := 0 to Nl - 1 do begin
    sum := 0;
    for i := 0 to Nl - 1 do begin
      sum := sum + aa[j, i] * x[i];
    end;
    y[j] := ba[j] - sum;
  end;

  // ZsNo\
  LL := 'vZ@';
  for i := 0 to Nl - 1 do begin
     if i < NL -1 then LL := LL + intTostr(rowNo[i] + 1) + ','
                  else LL := LL + intTostr(rowNo[i] + 1);
  end;
  memo1.Lines.Append(LL);

  // sԍ\
  memo1.Lines.Append('s No                Zɂ鍷');
  for k := 0 to Nl - 1 do begin
    LL := 'No = ' + inttostr(k + 1);
    n := 25 - length(LL);
    spl := '';
    for j := 1 to n do spl := spl + sp;
    memo1.Lines.Append(LL + spl + floattostr(y[rowNo[k]]));
  end;

  // x̒l\
  for k := 0 to Nl - 1 do begin
    memo1.Lines.Append('X' + inttostr(k + 1) + '=' + floatTostr(x[k]));
  end;

  result := 0;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var
  i, j, ch, k : integer;
  LL : string;
begin
  setlength(matA, Nl, Nl);
  setlength(matL, Nl, Nl);
  setlength(b, Nl);
  setlength(ba, Nl);
  setlength(lu , Nl, Nl);
  setlength(matU, Nl, Nl);
  setlength(rowNo, Nl);

  // matAɃObh1lǂݍ
  for i := 0 to Nl - 1 do
    for j := 0 to Nl - 1 do begin
      val(StringGrid1.Cells[i + 1,j + 1],matA[j,i], ch);
      if ch <> 0 then begin
        MessageDlg('a' + intTostr(j + 1) + ',' + intTostr(i + 1) + ' ̓͒l' + intTostr(ch) + 'ڂɌ肪L܂B', mtInformation,[mbOk], 0);
        exit;
      end;
    end;
  // bɃObh2lǂݍ
  for i := 0 to Nl - 1 do begin
    val(StringGrid2.Cells[1, i + 1], b[i], ch);
    if ch <> 0 then begin
      MessageDlg('b' + intTostr(i + 1) + '̓͒l' + intTostr(ch) + 'ڂɌ肪L܂B', mtInformation,[mbOk], 0);
      exit;
    end;
  end;

  memo1.Clear;

  // ΊpɃ[LI
  if triangular_matrix(k) = 0 then begin
    MessageDlg('zAaɃ[邩'
                + #13#10 + 'LU[܂B', mtInformation,[mbOk], 0);
    exit;
  end;


  k := 2;
  for i := 3 to NL do k := k * i;             // sgݍ킹
  setlength(perNo, k, Nl);                    // Ssgݍ킹zm
  permutation;                                // Ssgݍ킹쐬

  for i := 0 to Nl - 1 do rowNo[i] := i;      // vZ

  ch := k;                                    // ő僋[v

  // LuẢ@  @łȂꍇ
  exchange := 0;
  j := 0;   // @łꍇ 0  oȂꍇ 1  Ίpl0̏ꍇ 2
  // LuɏI܂ŌJԂ
  // k = 0 ͏ݒlȂ̂1`
  for k := 1 to ch do begin
    j := LUecomposition;                      // LU
    if j = 1 then begin                       // ΊpɃ[
      rowmatinc(k);                           // s̈ړ
      inc(exchange);
    end;
    if j = 0 then break;                      // @ŏI
  end;
  // @oȂ
  if diagonal < Nl then
    MessageDlg('LU𒆂ɑΊp[܂A͒lĉB', mtInformation,[mbOk], 0);
  memo1.Lines.Append('ČvZ Row= ' + intTostr(exchange));
  if j = 1 then begin
    LL := 'vZ@';
    for i := 0 to Nl - 1 do begin
      if i < NL -1 then LL := LL + intTostr(rowNo[i] + 1) + ','
                   else LL := LL + intTostr(rowNo[i] + 1);
    end;
    memo1.Lines.Append(LL);
  end;
end;

// eXgf[^[̑Iݒ
procedure TForm1.testset;
var
  i, j : integer;
begin
  GridSet(Nltest, Nltest);
  Nl := Nltest;
  for i := 1 to Nltest do
    for j := 1 to Nltest do begin
      case radiogroup1.ItemIndex of
        0: StringGrid1.Cells[i,j] := floatTostr(mattestA[j-1, i-1]);
        1: StringGrid1.Cells[i,j] := floatTostr(mattestB[j-1, i-1]);
        2: StringGrid1.Cells[i,j] := floatTostr(mattestC[j-1, i-1]);
        3: StringGrid1.Cells[i,j] := floatTostr(mattestD[j-1, i-1]);
        4: StringGrid1.Cells[i,j] := floatTostr(mattestE[j-1, i-1]);
      end;
    end;
  for i := 1 to Nltest do begin
    case radiogroup1.ItemIndex of
      0: StringGrid2.Cells[1,i]  := floatTostr(btestA[i-1]);
      1, 2, 3, 4 : StringGrid2.Cells[1,i]  := floatTostr(btestB[i-1]);
    end;
  end;
  LabeledEdit1.Text := intTostr(Nltest);
  memo1.Clear;
end;

// ObhTCY̕ύX
procedure TForm1.BitBtn2Click(Sender: TObject);
var
  ch : integer;
begin
  val(LabeledEdit1.Text, Nl, ch);
  if ch <> 0 then begin
    MessageDlg('N̓͒l' + intTostr(ch) + 'ڂɌ肪L܂B', mtInformation,[mbOk], 0);
    exit;
  end;
  GridSet(Nl, Nl);
end;

// eXgf[^[Zbg
procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  testset;
end;

// l̐ݒ
procedure TForm1.FormCreate(Sender: TObject);
begin
  testset;
end;

end.
